"""Sample solution for the CS444 image classification task.  

This solution just runs a 1-Nearest Neighbor classifier on the raw
images.

This is not a very good solution! 

author: Nathan Sprague
version: 10/2014

"""

import sklearn.neighbors 
import numpy as np
import pa3util


def knn_classify(show_results=False):
    """
    Classify the test data using the 1-nearest neighbor algorithm.
    This method saves a .csv file in the appropriate format. 

    Parameter: 
    show_results - set this to True if you want to see which images
                   are being classified as people. 
    """
    
    # First load the data...
    train_data = np.load('data/train_data.npy')
    train_labels = np.load('data/train_labels.npy')
    test_data = np.load('data/test_data.npy')

    # "Train" the classifier... 
    knn = sklearn.neighbors.KNeighborsClassifier(1)
    knn.fit(train_data, train_labels)

    # Classify the test data and save the results. 
    predict = knn.predict(test_data)
    pa3util.generate_submission(predict, 'test_submission.csv')
    
    if show_results:
        pa3util.show_results(test_data, predict)
    
if __name__ == "__main__":
    knn_classify(True)
